﻿
.LA 160000

ERRFDD=52	;адрес, куда сохраняется номер ошибки
;ячейки рабочей области драйвера дисковода
CSRW=0		;копия по записи регистра состояния КНГМД
CURTRK=2	;адрес текущей дорожки (адрес одного из следующих байтов из таблицы)
TRKTAB=4	;таблица текущих дорожек
TDOWN=10	;задержка опускания головки
TSTEP=12	;задержка перехода с дорожки на дорожку
TRKCOR=14	;дорожка начала предкомпенсации
BRETRY=15	;число попыток повтора при ошибке
FLAGS=16	;рабочая ячейка драйвера
FILLB=17	;код заполнения при форматировании
FLGPTR=20	;указатель на байт признаков (адрес одного из следующих байтов из таблицы)
FLGTAB=22	;таблица признаков
ADDR=26		;адрес начала массива данных в ОЗУ (обязательно чётный)
WCNT=30		;количество слов для пересылки
SIDE=32		;номер стороны диска
TRK=33		;номер дорожки
UNIT=34		;номер привода
SECTOR=35	;номер сектора
WRTVAR=36	;значение, записываемое при форматировании
MARKER=40	;буфер маркера при записи
FREE=42		;длина пустого остатка сектора
INTIME=44	;счётчик длительности индекса
BUF4=46		;буфер для сохранения вектора 4
BUFSP=50	;буфер для сохранения SP
BUFPSW=52	;буфер для сохранения PSW
CRETRY=54	;счётчик повторов при ошибке
TURNS=55	;число оборотов диска при поиске сектора
SECRET=56	;число повторных попыток поиска сектора
ERRNUM=57	;буфер для номера ошибки
MAXSEC=60	;число секторов на дорожке
HOLTIN=62   ;время задержки после индекса
SECLEN=64   ;длина сектора в словах

;изменение 1.
;поддержка только 2 приводов A: и B:

COMD=177130
COMK=177660
REG16=177716
IF0=177656		;данные
IF1=177654		;ошибок			предкомпенсация
IF2=177652		;счетчик сект.	счетчик сект.
IF3=177650		;номер сектора	номер сектора
IF4=177646		;цилиндр млад.	цилиндр млад.
IF5=177644		;цилиндр старш.	цилиндр старш.
IF6=177642		;SDH			SDH
IF7=177640		;состояния		команд
ZF6=177622		;А состояния	упр.биты
ZF7=177620		;адрес привода	----------

; Ячейки, используемые драйвером винчестера
LD.NUM = TRKTAB+2	; номер логического диска для обмена данными с винтом
CYLVOL = WRTVAR		; ёмкость цилиндра - это произведение числа головок на число секторов
HD.SEC = MARKER		; ёмкость дорожки - это количество секторов
HD.HEA = MARKER+1	; кол-во головок
LDBLLO = FREE		; номер блока мл.\ начальный блок активного раздела
LDBLHI = INTIME		; номер блока ст./
LD.VOL = CRETRY		; ёмкость раздела
LD.FLG = SECRET		; флаги-признаки раздела
HD.BLK = HOLTIN		; относительный номер блока лог диска, с которого начинается обмен данными.
MBRCRC = SECLEN		; контрольная сумма вышеописанных параметров
;LD.VOL и LD.FLG - должны быть два слова подряд
;LD.VOL и LD.FLG - записывается целое слово, используется только мл. байт
;
;CYLVOL и HD.SEC, HD.HEA- должны быть два слова подряд
;
;LDBLLO и LDBLHI - должны быть два слова подряд

START:	BR		BOOT0	; BOOT0:  Автоматическая загрузка
		BR		BOOT1	; BOOT1:  Загрузка с выбранного привода
		BR		RWBLK	; RWBLK:  Чтение-запись по номеру блока
		BR		RWSEC	; RWSEC:  Чтение-запись по номеру сектора
		BR		INIT	; INIT:   Инициализация рабочей области
		JMP		FORMAT	; FORMAT: Форматирование дорожки
		JMP		EXT		; EXT:    Расширенная арифметика
; BOOT0: П/п автоматической загрузки
BOOT0:	MOV		PC,R0	; R0 < 0 - признак автозагрузки с винта					;22
		CALL	BOOTC	; Пробуем загрузиться с винта
		CLR		R0		; Начнём с нулевого привода
		CALL	BOOTC	; Пробуем загрузиться с привода 0
		MOV		#1, R0	; Там не получилось, пробуем с привода 1
; BOOT1: Загрузка с выбранного привода
BOOT1:	CALL	BOOTC	; Загружаем стандартным загрузчиком
; STOP:	Остановка двигателя НГМД и выход из п/п
STOP:	CLR		(R3)															;46
		CLR		@#177130
		CLR		@#177660
		RETURN

; ───────────────────────────────────────────────────────────────────────────
; продолжение п/п загрузки и запуска загрузчика
BOOTC:	CALL	BOOTF				; Перехват функций загрузки с винта			;62
		MOV		#400, R1			;    длиной 400 слов (1000 байт)
		MOV		#1000, R2			;    с адреса 1000
		BR		2$
		JMP		GRUZND				;1600100 - точка входа в отладчик			;100

2$:		CLR		R0					; Читаем нулевой блок
		CALL	RWBLK				; Прочитаем...
		BCS		1$					;    не получилось - выход
		MOV		#1000, R2
		CMP		(R2)+, #240			; Загрузчик начинается с NOP?
		BNE		1$					; Нет - выход
		CMP		(R2), #5			; Вторая команда - RESET?
		BEQ		1$					; Да - диск не системный, выход
		MOVB	UNIT(R3), R0		; Вспомним, откуда это мы загрузились
		MOV		#1000, SP			; Установим стек
		CALL	-(R2)				; Запускаем загрузчик
		HALT						; останов, если загрузчик вместо того, чтобы дальше работать, вернулся сюда
1$:		RETURN						; Вот и все

		NOP		;все нижеследующие п/п постараться оставить на своих местах.
; RWSEC: Чтение-запись по номеру сектора
RWSEC:	BR		SUBRW

; INIT:	П/п инициализации рабочей области
INIT:	CLR		(R3)				; Очистим копию РС КНГМД
		MOV		#177777, TRKTAB(R3)	; Заполним таблицу текущих дорожек
		MOV		#177777, TRKTAB+2(R3)
		MOV		#10000., TDOWN(R3)	; Время опускания головки
		MOV		#10000., TSTEP(R3)	; Время перехода дорожки
		MOVB	#32., TRKCOR(R3)	; Дорожка начала предкомпенсации
		MOVB	#20., BRETRY(R3)	; Число повторов при ошибке
		CLRB	FLAGS(R3)			; Очистим флаги
		CLR		FLGTAB(R3)			;    и таблицу признаков
		CLR		FLGTAB+2(R3)
		MOV		#10., MAXSEC(R3)	; Занесём число секторов на дорожке = 10
		RETURN
; End of function INIT

; RWBLK: П/п чтения-записи по номеру блока
RWBLK:	MOV		#10, R4
		MOVB	MAXSEC(R3), R5		; число секторов на дорожке
		SWAB	R5					; делим ст. байт R0 на ст. байт R5
1$:		CMP		R5, R0
		BHI		2$
		SUB		R5, R0
		SEC
2$:		ROL		R0					; Частное накапливается в мл. байте R0
		SOB		R4, 1$
		MOVB	R0, R4				; В мл. байте номер дорожки, сохраним его
		CLRB	R0
		SWAB	R0					; Получили остаток от деления
		INC		R0					; Номер сектора на единичку больше
		CLRB	SIDE(R3)			; Пока мы на нижней стороне
		CMP		R0, MAXSEC(R3)		; Этот сектор за пределами дорожки?
		BLE		3$					; Нет - полный порядок
		INCB	SIDE(R3)			; Да - значит он на другой стороне
		SUB		MAXSEC(R3), R0		;    и номер у него другой
3$:		CALL	SETPTR				; Установим указатель на байт признаков
		BITB	#2, @FLGPTR(R3)		; Диск односторонний?
		BEQ		4$					; Нет - оставим все как есть
		ASRB	SIDE(R3)			; Да - сторона всегда 0,
		ROLB	R4					;    а дорожка уже другая
4$:		MOVB	R4, TRK(R3)			; Запишем результаты: дорожка,
		MOVB	R0, SECTOR(R3)		;    сектор,
		MOV		R1, WCNT(R3)		;    число слов,
		MOV		R2, ADDR(R3)		;    адрес буфера
; SUBRW: П/п чтения-записи по номеру сектора ! обязательно должно быть 160372
SUBRW:	CALL	STORSP				; сохраняем SP, PSW и т.п.
		TSTB	SECTOR(R3)			; Какой сектор нужен?
		BEQ		ERR12				; Нулевых у нас нет, ошибка 12
		CMPB	SECTOR(R3),MAXSEC(R3)   ; Сектор больше максимального?
		BHI		ERR12				; Таких нет, ошибка 12
		CMPB	SIDE(R3),#1			; Сторона больше максимальной?
		BHI		ERR12				; Да - опять ошибка 12
		CMPB	UNIT(R3),#2			; а вообще, может нам винт нужен?
		BHIS	FHDD				; да - идём обрабатывать винт
		CLRB	@#ERRFDD			; Пока ошибок нет
		BICB	#30, FLAGS(R3)		; Пока не записываем
		TST		WCNT(R3)			; Сколько слов будем пересылать?
		BEQ		QUIT				; 0 - ничего делать не надо, выход
		BPL		READ				; больше 0 - будем читать
; П/п записи массива
		NEG		WCNT(R3)			; Нормализуем длину
		BISB	#20, FLAGS(R3)		; Установим признак записи
		MOV		#175641, MARKER(R3)	; Запомним маркер данных
		BITB	#1, FLAGS(R3)		; Записываем скрытно?
		BEQ		1$					; Нет - идём дальше
		MOV		#174241, MARKER(R3)	; Да - запомним специальный маркер
1$:		CALL	ENGINE				; ENGINE: Включим двигатель, запомним привод
		BIT		#4, (R4)			; Защита записи есть?
		BEQ		MAIN				; Нет - продолжить работу
		MOV		#1, R0				; Есть - ошибка 1
		BR		ERR

FHDD:	JMP		FIZIKH				; да - пересчёт для винта

; ───────────────────────────────────────────────────────────────────────────
; READ:	П/п чтения массива
READ:	CALL	ENGINE				; ENGINE: Включим двигатель, запомним привод
		MOV		#400, SECLEN(R3)	; Сектора стандартной длины
		BITB	#4, @FLGPTR(R3)		; А они ли нам нужны?
		BEQ		MAIN				; Да - продолжить работу
		MOV		#1000, SECLEN(R3)	; Нет - сектора удвоенной длины
; MAIN:	Основная часть п/п чтения/записи массива
MAIN:	CALL	GOTRK				; GOTRK: Позиционируем на нужную дорожку
		CALL	CORR				; CORR: Включим схему прекоррекции
		MOVB	BRETRY(R3), CRETRY(R3)  ; Число попыток - в буфер
; Получение заголовка сектора
		MOVB	#10, ERRNUM(R3)		; Предполагаем ошибку 10
		MOVB	#20., TURNS(R3)		; На операцию отводим 20. оборотов

1$:		CALL	FINDH				; FINDH: Найдём маркер заголовка
		BCC		2$					; Нашли - идём дальше
3$:		MOVB	ERRNUM(R3), R0		; Не нашли - выходим с ошибкой
		BR		ERR
; ───────────────────────────────────────────────────────────────────────────
2$:		TSTB	(R4)				; Информация получена?
		BPL		2$					; Нет - подождём
		MOV		(R5), R0			; Теперь прочитаем ее
4$:		TSTB	(R4)				; Хотим ещё информации!
		BPL		4$					; Дождёмся ее появления
		MOV		(R5), R1			;    и заберём ее
		CALL	TSTCRC				; TSTCRC: Проверим CRC
		BNE		5$					; Ошибки нет - идём дальше
		MOVB	#2, ERRNUM(R3)		; Ошибка 2!
		DECB	CRETRY(R3)			; Остались ещё попытки?
		BNE		1$					; Да - повторим чтение
		BR		3$					; Видно, не судьба! Выходим с ошибкой
; ───────────────────────────────────────────────────────────────────────────
5$:		BIC		#177774, R1			; Выделяем код длины сектора
		BITB	#4, @FLGPTR(R3)		; Какие сектора нам были нужны?
		BNE		LONG				; LONG: Длинные - посмотрим...
		CMPB	R1, #2				; Короткие. А на диске какие?
		BEQ		WORK				; WORK: Тоже короткие. Порядок, идём дальше
		DECB	CRETRY(R3)			; Как там дела с попытками?
		BNE		1$					; Есть ещё - повторим все сначала
; ERR12: Выход с ошибкой
ERR12:	MOV		#12, R0				; Выходим с ошибкой 12
ERR:	JMP		ERROR				; ERROR: Идём на обработку и выход
; ───────────────────────────────────────────────────────────────────────────
QUIT:	JMP		EXIT				; EXIT: Идём на нормальный выход
; ───────────────────────────────────────────────────────────────────────────
LONG:	CMPB	R1, #2				; Нужны длинные сектора, а какие здесь?
		;    ОШИБКА: На самом деле код длинных секторов (1024 байта на сектор) - 3, а не 2
		;вот сколько прошивок ни посмотрел, везде так. никто это не исправляет, значит это не ошибка,
		;а фича	такая - принципиальная неподдерживаемость длинных секторов
		BNE		ERR12				; ERR12: Длинные - выходим с ошибкой 12
; WORK:	Собственно п/п чтения
WORK:	MOVB	BRETRY(R3), CRETRY(R3)	; Восстановим счётчик по BRETRY
		MOVB	#6, SECRET(R3)		; На поиск сектора - 6 попыток
		CLR		FREE(R3)			; Остаток сектора отсутствует
		CMP		WCNT(R3), SECLEN(R3)	; Читать нужно больше одного сектора?
		BHI		1$					; Да - идём читать
		MOV		SECLEN(R3), FREE(R3)
		SUB		WCNT(R3), FREE(R3)	; Вычислим длину остатка
1$:		MOVB	#5, ERRNUM(R3)		; Прогнозируем ошибку 5
2$:		MOVB	#20., TURNS(R3)		; На операцию отводим 20. оборотов
3$:		CALL	FINDH				; FINDH: Ищем маркер заголовка
		BCC		4$					; Нашли - идём дальше
		MOVB	ERRNUM(R3), R0		; Кончились обороты - выходим
		BR		ERR					;    с ошибкой
; ───────────────────────────────────────────────────────────────────────────
4$:		TSTB	(R4)				; Готовность данных есть?
		BPL		4$					; Нет - подождём
		CMP		SIDE(R3), (R5)		; Нужная дорожка и сторона?
		BEQ		5$					; Да - идём дальше
		DECB	SECRET(R3)			; Минус одна попытка
		BEQ		6$					; Кончились - выход с ошибкой
		CALL	GOTO00				; GOTO00: Позиционируем на дорожку 00,
		CALL	GOTRK				; GOTRK:  вернёмся на нужную
		BR		3$					;    и попытаемся ещё раз
; ───────────────────────────────────────────────────────────────────────────
6$:		MOV		#4, R0				; Выходим с ошибкой 4
		BR		ERR					; ERR
; ───────────────────────────────────────────────────────────────────────────
5$:		TSTB	(R4)				; Ждём готовности данных
		BPL		5$					; Не готовы - повторять...
		MOV		(R5), R1			; Получим номер сектора
		SWAB	R1					;    поместим его в младший байт
		CMPB	SECTOR(R3), R1		; Этот сектор ищем?
		BEQ		7$					; Да - будем его читать
		MOV		SECLEN(R3), R0		; Нет - возьмём длину данных,
		ADD		#27, R0				;    прибавим длину заголовка
		CALL	FICT				; FICT:   и пропустим их
		BR		3$					; Повторим процедуру ещё раз
; ───────────────────────────────────────────────────────────────────────────
7$:		CALL	TSTCRC				; TSTCRC: Проверим CRC
		BNE		8$					; Совпала - идём дальше
		MOVB	#2, ERRNUM(R3)		; Если что, это будет ошибка 2
		DECB	CRETRY(R3)			; Одной попыткой меньше
		BNE		2$					; Ещё остались - поищем снова
		MOVB	ERRNUM(R3), R0		; Нет - выходим с ошибкой
		BR		ERROR
; ───────────────────────────────────────────────────────────────────────────
8$:		MOV		SECLEN(R3), R1		; Получим длину сектора
		SUB		FREE(R3), R1		; Вычислим длину используемой части
; Чтение сектора
		BITB	#20, FLAGS(R3)		; Будем записывать?
		BEQ		9$					; Нет - значит, читать
		JMP		WRSEC				; Да - идём на запись сектора
; ───────────────────────────────────────────────────────────────────────────
9$:		CALL	FINDS				; FINDS: Ищем зону синхронизации
		TSTB	SECRET(R3)			; Нашли?
		BEQ		10$					; Нет - пробуем снова
		CALL	STREAD				; STREAD: Начинаем чтение!
		MOV		#600., R0
12$:	TSTB	(R4)				; Данные готовы?
		BMI		11$					; Да - посмотрим их
		SOB		R0, 12$				; Больше ждать нельзя?

10$:	MOVB	#11, ERRNUM(R3)		; Да - прогнозируем ошибку 11
		DECB	CRETRY(R3)			; Одной попыткой меньше
		BNE		2$					; Попытки есть - повторим операцию
		MOVB	ERRNUM(R3), R0		; Кончились - выйдем с ошибкой
		BR		ERROR
; ───────────────────────────────────────────────────────────────────────────
11$:	TST		(R5)				; Пропустим маркер A1A1
13$:	TSTB	(R4)				; Готовность данных есть?
		BPL		13$					; Нет - ждём
		MOV		(R5), R0			; Прочитаем данные
		CMP		#120773, R0			; Обычный сектор?
		BEQ		14$					; Да - идём дальше
		CMP		#120770, R0			; Скрытый сектор?
		BNE		10$					; Что-то иное - ошибка
		BITB	#1, FLAGS(R3)		; Можно читать скрытые данные?
		BNE		14$					; Да - будем читать
		MOV		#13, R0				; Нельзя - выходим с ошибкой 13
		BR		ERROR
; ───────────────────────────────────────────────────────────────────────────
14$:	CALL	RDSEC				; RDSEC: Прочитаем сектор
		CALL	TSTCRC				; TSTCRC: Проверим CRC
		BNE		NEXT				; Совпала - посмотрим следующий сектор
		MOVB	#1, ERRNUM(R3)		; Не совпала - ошибка 1
		DECB	CRETRY(R3)			; Попытки кончились?
		BNE		2$					; Нет - попробуем ещё раз
		MOVB	ERRNUM(R3), R0		; Кончились - выходим с ошибкой
		BR		ERROR
; ───────────────────────────────────────────────────────────────────────────
; Мультисекторные операции
NEXT:	SUB		SECLEN(R3), WCNT(R3)	; Сектор обработали, вычтем из длины
		BLE		EXIT				; Массив кончился - выход
		INCB	SECTOR(R3)			; Нет - следующий сектор
		CMPB	SECTOR(R3), MAXSEC(R3)	; Конец дорожки?
		BLOS	1$					; Нет - продолжим обработку
		BIT		#40, (R3)			; Верхняя сторона?
		BNE		2$					; Да - следующая дорожка
		BITB	#2, @FLGPTR(R3)		; Диск односторонний?
		BNE		2$					; Да - продолжим обработку
		MOVB	#1, SIDE(R3)		; Нет - установим верхнюю сторону
		BIS		#40, (R3)
		BR		3$					; Перейдём к обработке
; ───────────────────────────────────────────────────────────────────────────
2$:		INCB	TRK(R3)				; Следующая дорожка
		CALL	GOTRK				; Позиционируем на нее
		CLRB	SIDE(R3)			; Установим нижнюю сторону
		BIC		#40, (R3)
3$:		MOVB	#1, SECTOR(R3)		; Теперь сектор будет первым
		CALL	CORR				; Переключить прекоррекцию

1$:		ADD		SECLEN(R3), ADDR(R3)	; Получим новый начальный адрес
		ADD		SECLEN(R3), ADDR(R3)
		JMP		WORK				; WORK: Идём на чтение очередного сектора
; ───────────────────────────────────────────────────────────────────────────

; Обработка прерывания по вектору 4
VECT4:	TST		(R5)				; Сбросить данные
		MOV		#7, R0				; Заносим код ошибки 7
		BR		ERROR
; ERROR: Выход с ошибкой
; ENO: Выход с ошибкой
ENO:	MOV		(SP),R0				; адрес возврата
		MOVB	(R0),R0				; оттуда возьмём код ошибки
ERROR:	MOVB	R0, ERRNUM(R3)
		MOVB	R0, @#ERRFDD		; Код ошибки - на место!
		MOVB	#1, SECRET(R3)		; Установим бит C в буфере
		BR		EXIT1				; EXIT1: Идём на выход
; ───────────────────────────────────────────────────────────────────────────
; ENDS:	Выход без ошибки
ENDS:
EXIT:	CLRB	SECRET(R3)			; Сбросим бит C в буфере
		CLRB	@#ERRFDD			; и код ошибки
EXIT1:	MOV		BUF4(R3),@#4		; Восстановить вектор 4
		MTPS	BUFPSW(R3)			; Восстановить PSW
		CCC							; Сбросить все признаки
		RORB	SECRET(R3)			; Бит C - из буфера в PSW
		MOV		BUFSP(R3),SP		; Восстановить SP
		JMP		STOP				; Возврат

; TSTCRC: П/п проверки CRC
TSTCRC:	TSTB	(R4)				; Ждём готовности данных
		BPL		TSTCRC
		MOV		#15., R2			; CRC появится не позже 15. циклов
1$:		BIT		#40000, (R4)		; CRC сошлась?
		BNE		2$					; Да - выход
		SOB		R2, 1$				; Нет - очередной цикл
2$:		RETURN						; Если бит Z=1, то произошла ошибка
; End of function TSTCRC


; RDSEC: П/п чтения сектора в буфер; R1 - число слов для пересылки
RDSEC:	MTPS	#340				; Маскируем прерывания
		MOV		ADDR(R3), R2		; Получим адрес буфера
1$:		TSTB	(R4)				; Ожидаем данные
		BPL		1$
		MOV		(R5), R0			; Читаем два байта,
		SWAB	R0					; делаем из них нормальное слово,
		MOV		R0, (R2)+			;    которое помещаем в буфер
		SOB		R1, 1$				; Читаем заказанное число слов
		MOV		FREE(R3), R1		; Получаем длину остатка
		BEQ		2$					; Остатка нет - сразу выходим
3$:		TSTB	(R4)				; Ждём данные
		BPL		3$
		TST		(R5)				; Вхолостую читаем остаток
		SOB		R1, 3$				;    требуемой длины
		MTPS	BUFPSW(R3)			; Восстанавливаем PSW
2$:		RETURN
; End of function RDSEC


; FINDS: П/п поиска синхропоследовательности
FINDS:	TST		(R5)				; Сбрасываем прочитанное значение
		MOVB	#100., SECRET(R3)	; Будем искать 100. циклов
1$:		TSTB	(R4)				; Ждём готовности
		BPL		1$
		MOV		(R5), R0			; Получим прочитанные данные
		BEQ		2$					; Это 0 - на выход
		INC		R0					; Это 177777?
		BEQ		2$					; Да - на выход
		DECB	SECRET(R3)			; Циклы кончились?
		BNE		1$					; Нет - повторяем поиск
2$:		RETURN
; End of function FINDS
; ───────────────────────────────────────────────────────────────────────────
; П/п чтения двух слов (не используется)
;11$:	TSTB	(R4)				; Ждём готовности
;		BPL		11$
;		MOV		(R5), R0			; Получаем первое слово
;12$:	TSTB	(R4)				; Ждём готовности
;		BPL		12$
;		MOV		(R5), R1			; Получаем второе слово
;		RETURN


; STREAD: П/п запуска чтения
STREAD:	BIS		#400, (R3)			; Установим признак "начало чтения"
		MOV		(R3), (R4)			;    и запишем в регистр
		BIC		#400, (R3)			; Снимем признак
		MOV		#10, R0
		SOB		R0, .				; Небольшая задержка...
		MOV		(R3), (R4)			;    и снова запишем в регистр
		RETURN
; End of function STREAD

; ───────────────────────────────────────────────────────────────────────────
; П/п поиска начала индекса (не используется)
;11$:	TST		(R4)				; Индекс есть?
;		BMI		11$					; Да - ждём исчезновения
;		BIS		#400, (R3)			; Установим признак "начало чтения"
;		MOV		(R3), (R4)			;    и запишем в регистр
;12$:	TST		(R4)				; Индекса ещё нет?
;		BPL		12$					; Да - ждать появления
;		MOV		HOLTIN(R3), R0
;		SOB		R0, .				; Задержимся...
;		BIC		#400, (R3)			; Сбросим признак "начало чтения"
;		MOV		(R3), (R4)			;    и запишем в регистр
;		RETURN

; FINDH: П/п поиска адресного маркера
FINDH:	MOV		#15., R0
1$:		TST		(R5)				; Вхолостую прочитаем
		SOB		R0, 1$				;    15. слов
		CLR		INTIME(R3)			; Начинаем ожидание индекса
		BICB	#40, FLAGS(R3)		; Пока индекса нет
FH2$:	BITB	#30, @FLGPTR(R3)	; Сектор задан задержкой?
		BEQ		3$					; Нет - обрабатывать
		CMPB	SECTOR(R3), #1		; Да - нужен первый сектор?
		BNE		3$					; Второй и далее задаются заголовками
		MOV		#1474, HOLTIN(R3)	;чудо-код, независимо от того,
		BR		5$					;как задан сектор и какой нужен сектор
; ───────────────────────────────────────────────────────────────────────────
3$:		MOV		#1474, HOLTIN(R3)	;выставляем вот такую задержку
5$:		CALL	INDEX				; INDEX: Проверим наличие диска и обороты
		BCS		6$					; Обороты кончились - выходим
		BEQ		5$					; Какие данные? Нули пропустим
		COM		R0					; 177777?
		BEQ		5$					; Да - тоже пропустим
7$:		CALL	INDEX				; INDEX: Проверим наличие диска и обороты
		BCS		6$					; Обороты кончились - выходим
		BEQ		8$					; Какие данные? Нули - синхро
		COM		R0					; 177777?
		BNE		7$					; Нет - пропустим
; Проверка адресного маркера
8$:		MOV		#3, R1
9$:		MOV		(R5), R0			; Читаем данные
		BEQ		10$					; Нули - продолжаем
		COM		R0					; 177777?
		BNE		5$					; Нет - повторяем поиск
10$:	SOB		R1, 9$				; Да - повторяем 3 раза
		CALL	STREAD				; STREAD: Запускаем на чтение
		MOV		HOLTIN(R3), R0		; берём задержку
11$:	TSTB	(R4)				; Готовность есть?
		BMI		12$					; Есть - считываем данные
		SOB		R0, 11$				; Нет - ждём
		BR		FH2$				; Надоело ждать - повторяем поиск
; ───────────────────────────────────────────────────────────────────────────
12$:	TST		(R5)				; Пропускаем A1A1
13$:	TSTB	(R4)				; Ждём готовности
		BPL		13$
		MOV		(R5), R0			; Есть - берём данные
		CMP		#120776, R0			; Адресный маркер (A1FE)?
		BEQ		14$					; Да - нормальный выход
		CMP		#120773, R0			; Нет - маркер данных (A1FB)?
		BEQ		15$					; Да - пропускаем сектор
		CMP		#120770, R0			; Нет - маркер скрытых данных (A1F8)?
		BNE		FH2$				; Нет - повторяем поиск сначала
15$:	CALL	FRESEC				; FRESEC: Да - пропускаем сектор
		BR		FH2$				; Повторяем поиск сначала
; ───────────────────────────────────────────────────────────────────────────
14$:	CLC
6$:		RETURN
; End of function FINDH



; INDEX: П/п проверки диска и числа оборотов
INDEX:	TST		(R4)				; Индекс есть?
		BPL		1$					; Нет - идём проверять
		BITB	#40, FLAGS(R3)		; Индекс есть - он уже был?
		BNE		2$					; Был - идём увеличивать время
		CLR		INTIME(R3)			; Только что появился - очистим время
		BISB	#40, FLAGS(R3)		;    и запомним факт появления
		DECB	TURNS(R3)			; Закончился последний оборот?
		BNE		3$					; Нет - нормальный выход
		SEC							; Да - выход с ошибкой
		RETURN
; ───────────────────────────────────────────────────────────────────────────
3$:		CLC
		MOV		(R5), R0			; Забираем данные
		RETURN
; ───────────────────────────────────────────────────────────────────────────
1$:		BITB	#40, FLAGS(R3)		; Индекса нет - а он был?
		BEQ		2$					; Нет и не было - идём считать время
		CLR		INTIME(R3)			; Только что исчез - очистим время
		BICB	#40, FLAGS(R3)		;    и запомним факт исчезновения
		BR		3$					; Нормально выходим
; ───────────────────────────────────────────────────────────────────────────
2$:		INC		INTIME(R3)			; Ещё один такт индекс не менялся
		CMP		INTIME(R3), #60000	; Ну сколько можно! Пора кончать?
		BLOS	3$					; Не пора - нормальный выход
		MOV		#6, R0				; Терпение кончилось -
		JMP		ERROR				; ERROR:   значит диска нет - ошибка 6
; End of function INDEX



; ENGINE: П/п выбора устройства
ENGINE:	MOV		#177130, R4			; Заполняем рабочие регистры
		MOV		R4, R5				;    адресами PC
		TST		(R5)+				;    РД КНГМД
		BICB	#4, FLAGS(R3)		; Очистим признак работы двигателя
		BIT		#20, (R3)			; Двигатель уже включён?
		BEQ		1$					; Нет - включим
		BISB	#4, FLAGS(R3)		; Да - установим признак
1$:		BIS		#20, (R3)			; Включим двигатель
		MOV		(R3), (R4)			;    и запишем в регистр
		BIC		#57, (R3)			; Сбросим все другие регистры
		TSTB	SIDE(R3)			; Сторона верхняя?
		BEQ		2$					; Да - идём дальше
		BIS		#40, (R3)			; Нет - включим нижнюю
2$:		BICB	#177776, UNIT(R3)	; Сбросим лишние биты
		MOVB	UNIT(R3), R1		; Получим номер привода
		MOV		R1, R0				; 
		INC		R0					; Получим нужную маску
		ASL		R0
		BISB	R0, (R3)			; Установим бит нужного привода
		ADD		R3, R1				; Получим базовый адрес
		ADD		#TRKTAB, R1			;    таблицы TRKTAB
		MOV		R1, CURTRK(R3)		; Настроим указатель CURTRK
		CALL	SETPTR				; SETPTR: Настроим указатель FLGPTR
		BITB	#4, FLAGS(R3)		; Мотор включён только что?
		BNE		3$					; Нет - выходим
		CLR		R1					; Да - подождём раскручивания
		SOB		R1, .
		SOB		R1, .
3$:		MOV		(R3), (R4)			; Записываем установки в регистр
		MOV		TDOWN(R3), R1		; Подождём опускания головки
		SOB		R1, .
		RETURN
; End of function ENGINE
; ───────────────────────────────────────────────────────────────────────────

; SETPTR: П/п настройки указателя FLGPTR
SETPTR:	CLR		FLGPTR(R3)				; Очистим указатель FLGPTR
		BICB	#177776, UNIT(R3)
		MOVB	UNIT(R3), FLGPTR(R3)	; Перешлём номер привода в FLGPTR
;		BIC		#177776, FLGPTR(R3)		; Отбросим лишние биты
		ADD		R3, FLGPTR(R3)			; Прибавим базовый адрес FLGTAB
		ADD		#FLGTAB, FLGPTR(R3)		;    получаем искомый адрес
		RETURN
; End of function SETPTR



; GOTRK: П/п позиционирования
GOTRK:	TSTB	TRK(R3)				; Нужна дорожка 00?
		BEQ		GOTO00				; Да - позиционируем прямо на нее
		TSTB	@CURTRK(R3)			; Положение головки известно?
		BPL		1$					; Да - будем искать требуемую
		CALL	GOTO00				; Нет - придётся сориентироваться
1$:		CMPB	@CURTRK(R3), TRK(R3)	; Нужная дорожка совпадает с текущей?
		BEQ		2$					; Да - так что же мы тут делаем?
		BHI		3$					; Нет - искомая ближе к центру?
		CALL	GOUP				; Да - шагаем к центру
		BR		1$					; Проверим, дошли ли
; ───────────────────────────────────────────────────────────────────────────
3$:		CALL	GODOWN				; Нет - шагнём к периферии
		BR		1$					; Проверим, дошли ли
; ───────────────────────────────────────────────────────────────────────────
2$:		MOV		#10000., R0			; Подождём успокоения головки
		SOB		R0, .
		RETURN						; Теперь можно и выйти
; End of function GOTRK


; GOUP:	Шаг к центру
GOUP:	INCB	@CURTRK(R3)			; Номер дорожки станет на 1 больше
		BMI		1$					; Таких дорожек нет - выходим с ошибкой
		BIS		#100, (R3)			; Все в порядке - шагать будем вперёд
		BR		3GO$				; Пойдём шагать
; ───────────────────────────────────────────────────────────────────────────
1$:		MOV		#4, R0				; Выход с ошибкой 4
		JMP		ERROR
; End of function GOUP

; GODOWN: Шаг к	периферии
GODOWN:	DECB	@CURTRK(R3)			; Номер дорожки станет на 1 меньше
		BIT		#1, (R4)			; Дошли до дорожки 00?
		BEQ		2$					; Нет - можно шагать
		CLRB	@CURTRK(R3)			; Дошли: теперь текущая - 00
		RETURN						;    и можно выйти
; ───────────────────────────────────────────────────────────────────────────
2$:		BIC		#100, (R3)			; Шагать будем назад
3GO$:	MOV		#200., R0			; Подготовим задержку
		MOV		(R3), (R4)			; Перешлём направление шага в регистр
		SOB		R0, .				; Подождём, пока контроллер "переварит"
		BIS		#200, (R3)			; Установим признак шага
		MOV		(R3), (R4)			;    и запишем в регистр
		MOV		TSTEP(R3), R0		; Получим задержку перехода дорожки
		SOB		R0, .				;    и задержимся
		BITB	#1, @FLGPTR(R3)		; Двойной шаг?
		BEQ		4$					; Нет - можно выходить
		BITB	#100, FLAGS(R3)		; Мы возвращаемся на 00?
		BNE		4$					; Да - возвращаться надо одинарным шагом
		MOV		(R3), (R4)			; Нет - придётся шагнуть ещё
		MOV		TSTEP(R3), R0		; Получим задержку перехода дорожки
		SOB		R0, .				;    и задержимся
4$:		BIC		#200, (R3)			; Очистим признак шага
		RETURN
; End of function GODOWN

; GOTO00: П/п возврата на дорожку 00
GOTO00:	MOVB	#200, @CURTRK(R3)	; Установим счётчик дорожек
		BISB	#100, FLAGS(R3)		; Возвращаться надо одинарным шагом
1$:		CALL	GODOWN				; GODOWN: Шагнём к периферии
		BIT		#1, (R4)			; Дошли до 00?
		BNE		2$					; Да - выходим
		TSTB	@CURTRK(R3)			; На какой дорожке должны находиться?
		BNE		1$					; Не на нулевой - ещё шагнём
		MOV		#3, R0				; На нулевой, а ее нет - ошибка 3
		BICB	#100, FLAGS(R3)		; Сбросим режим одинарного шага
		JMP		ERROR				; Выходим с ошибкой
; ───────────────────────────────────────────────────────────────────────────
2$:		CLRB	@CURTRK(R3)			; Дошли - текущая теперь нулевая
		BICB	#100, FLAGS(R3)		; Сбросим режим одинарного шага
		RETURN
; End of function GOTO00


; FRESEC: П/п пропуска сектора
FRESEC:	MOV		SECLEN(R3), R0		; Получим длину сектора
; П/п фиктивного чтения
FICT:	TST		(R4)				; Индекс есть?
		BMI		1$					; Да - ждём начала оборота
2$:		TST		(R4)				; Индекс все ещё есть?
		BMI		3$					; Да - оборот завершён
4$:		TSTB	(R4)				; Данные готовы?
		BPL		2$					; Нет - снова
		TST		(R5)				; Прочитаем данные вхолостую
		SOB		R0, 2$				;    требуемое число раз
		BR		5$					;    и выйдем
; ───────────────────────────────────────────────────────────────────────────
3$:		DECB	TURNS(R3)			; Все обороты вышли?
		BNE		6$					; Нет - попытаемся слова
		MOV		#5, R0				; Да - выходим с ошибкой 5
		JMP		ERROR
; ───────────────────────────────────────────────────────────────────────────
1$:		TST		(R4)				; Индекс исчез?
		BPL		4$					; Да - оборот начался
6$:		TSTB	(R4)				; Данные готовы?
		BPL		1$					; Нет - проверим индекс
		TST		(R5)				; Прочитаем данные вхолостую
		SOB		R0, 1$				;    требуемое число раз
5$:		RETURN						;    и вернёмся к основной работе
; End of function FICT
; End of function FRESEC

; ───────────────────────────────────────────────────────────────────────────
; WRSEC: П/п записи сектора
; Входные параметры: R1 - число слов для записи
WRSEC:	MOV		ADDR(R3), R2		; Получим начальный адрес массива
		MOV		#11., R0			; В маркере будет 11. 4E4E
		MTPS	#340				; При записи нам не мешать!
		CALL	WRMAR				; Запишем маркер данных

1$:		TSTB	(R4)				; Готовность есть?
		BPL		1$					; Нет - ждём
		MOV		(R2)+, (R5)			; Запишем первое слово данных
		MOV		(R3), (R4)			; Снимем признак записи маркера
		BR		2$					;    и пойдём записывать данные
; ───────────────────────────────────────────────────────────────────────────
3$:		TSTB	(R4)				; Готовность есть?
		BPL		3$					; Нет - дождёмся
		MOV		(R2)+, (R5)			; Запишем слово данных
2$:		SOB		R1, 3$				;    и так до конца
		MOV		FREE(R3), R1		; Получим длину пустого остатка сектора
		BEQ		4$					; Остатка нет - выходим сразу
5$:		TSTB	(R4)				; Готовность есть?
		BPL		5$					; Дожидаемся
		MOV		#0, (R5)			; Записываем нули
		SOB		R1, 5$				;    в нужном количестве
4$:		BIT		#40000, (R4)		; Ждём записи CRC
		BEQ		4$
		MOV		#47116, (R5)		; Записываем 4E4E
6$:		TSTB	(R4)				; Готовность есть?
		BPL		6$					; Нет - ждём
		TST		(R5)				; Прекращаем запись
		MTPS	BUFPSW(R3)			; Восстанавливаем PSW
		JMP		NEXT				; NEXT: Продолжаем запись массива


; WRMAR: П/п записи маркера данных
; Входные данные: R0 - число записываемых слов 4E4E
; ───────────────────────────────────────────────────────────────────────────
WRM1:	TSTB	(R4)				; Готовность есть?
		BPL		WRM1				; Нет - дождёмся
WRMAR:	MOV		#47116, (R5)		; Запишем 4E4E
		SOB		R0, WRM1			; Повторим заданное число раз
		MOV		#6, R0				; Запишем 12. нулевых байтов
3$:		TSTB	(R4)				; Готовность есть?
		BPL		3$					; Нет - ожидаем
		MOV		#0, (R5)			; Записываем нули
		SOB		R0, 3$				;    в нужном количестве
		BIS		#1000, (R3)			; Подготовим признак записи маркера
4$:		TSTB	(R4)				; Контроллер готов?
		BPL		4$					; Нет - ждём
		MOV		#120641, (R5)		; Записываем маркер A1A1
		MOV		(R3), (R4)			; Передаём признак в контроллер
		BIC		#1000, (R3)			; Заранее снимем признак
5$:		TSTB	(R4)				; Готовность есть?
		BPL		5$					; Нет - ожидаем
		MOV		MARKER(R3), (R5)	; Записываем маркер из буфера
		RETURN
; End of function WRMAR

; CORR:	П/п установки прекоррекции
CORR:	BIC		#2000, (R3)			; Снимем прекоррекцию
		CMPB	TRKCOR(R3), @CURTRK(R3) ; Надо включать на текущей дорожке?
		BHI		1$					; Нет - пропустим
		BIS		#2000, (R3)			; Пора - включим
1$:		MOV		(R3), (R4)			; Перешлём управляющее слово
		MOV		#200., R0
		SOB		R0, .				; Подождём, пока контроллер воспримет
		RETURN
; End of function CORR

; ───────────────────────────────────────────────────────────────────────────
; FORMAT: П/п форматирования
FORMAT:	CMPB	UNIT(R3),#2			;винт форматим фиктивно...
		BLO		0$
		RETURN

0$:		CALL	STORSP				; сохраняем SP, PSW и т.п.
		CALL	ENGINE				; Запустим двигатель
		CALL	GOTRK				; Позиционируем на нужную дорожку
		CALL	CORR				; Установим прекоррекцию
		BIT		#4, (R4)			; Защита записи включена?
		BEQ		1$					; Нет - начинаем форматировать
		MOV		#1, R0				; Да - ошибка 1
2$:		JMP		ERROR				; Выходим с ошибкой
; ───────────────────────────────────────────────────────────────────────────
1$:		SWAB	SIDE(R3)			; Обмениваем номера стороны и дорожки
		MOVB	FILLB(R3), WRTVAR(R3)	; Делаем слово-заполнитель
		MOVB	FILLB(R3), WRTVAR+1(R3)	;    из байта-заполнителя
		MOVB	MAXSEC(R3), R1		; Получим длину сектора
		MOV		#1001, R2			; Запомним номер сектора и код длины
		MOV		#1000., R0			; Время ожидания индекса
3$:		TST		(R4)				; Индекс есть?
		BPL		4$					; Исчез - начинаем записывать
		SOB		R0, 3$				; Есть - ждём исчезновения
5$:		TST		(R5)				; Так и не исчез - прекратим запись
		MOV		#6, R0				; Диск не вращается - ошибка 6
		SWAB	SIDE(R3)			; Вернём все на место
		BR		2$					; Выходим с ошибкой
; ───────────────────────────────────────────────────────────────────────────
; Запись на дорожку кода 4E4E
4$:		MOV		#6200, R0			; Установим максимальную длину
		MTPS	#340				; При записи нам не мешать
		MOV		#47116, (R5)		; Записываем 4E4E
6$:		TST		(R4)				; Индекс появился?
		BMI		7$					; Да - начинаем запись
8$:		TSTB	(R4)				; Готовность есть?
		BPL		8$					; Нет - ждём
		MOV		#47116, (R5)		; Записываем 4E4E
		SOB		R0, 6$				; И так до конца дорожки
		BR		5$					; Дорожка длинная, ошибка!
; ───────────────────────────────────────────────────────────────────────────
7$:		MOV		#16., R0			; В маркере будет 16. 4E4E (GAP1)
		MOV		#177241, MARKER(R3)	; Адресный маркер (FEA1) - в буфер
9$:		CALL	WRMAR				; WRMAR: Записываем адресный маркер
10$:	TSTB	(R4)				; Готовность есть?
		BPL		10$					; Нет - ожидаем
		MOV		SIDE(R3), (R5)		; Записываем номер стороны и дорожки
		MOV		(R3), (R4)			; Перешлём управляющее слово
11$:	TSTB	(R4)				; Готовность есть?
		BPL		11$					; Нет - дождёмся
		MOV		R2, (R5)			; Записываем номер сектора и код длины
		MOV		#11., R0			; В маркере будет 11. 4E4E (GAP2)
		MOV		#175641, MARKER(R3)	; Маркер данных (FBA1) - в буфер
12$:	BIT		#40000, (R4)		; Ждём записи CRC
		BEQ		12$
		CALL	WRMAR				; WRMAR: Записываем маркер данных
		MOV		SECLEN(R3), R0		; Получаем длину сектора
		DEC		R0					; Одно слово запишем сейчас
13$:	TSTB	(R4)				; Готовность есть?
		BPL		13$					; Нет - ожидаем
		MOV		WRTVAR(R3), (R5)	; Записываем заполнитель
		MOV		(R3), (R4)			; Перешлём управляющее слово
14$:	TSTB	(R4)				; Готовность есть?
		BPL		14$					; Нет - дождёмся
		MOV		WRTVAR(R3), (R5)	; Записываем заполнитель
		SOB		R0, 14$				; И так до конца сектора
		INC		R2					; Увеличим номер сектора
		MOV		#24., R0			; В маркере будет 24. 4E4E (GAP3)
;    Примечание. Если увеличить GAP3 до 24-27 слов, то запись будет производиться так
; же быстро, как и чтение (обычно заголовок очередного сектора проскакивает, и дорожка
; записывается не за один, а за 10 оборотов). Однако при превышении этой величиной
; определённого	значения конец последнего сектора дорожки может наложиться на ее
; же начало.
		BIT		#4, @FLGPTR(R3)		; Сектора длинные?
		BEQ		15$					; Нет - все нормально
		MOV		#72, R0				; Да - будет 116. 4E4E (можно увеличить до 75)
15$:	MOV		#177241, MARKER(R3)	; Адресный маркер (FEA1) - в буфер
16$:	BIT		#40000, (R4)		; Ждём записи CRC
		BEQ		16$
		SOB		R1, 9$				; И так все сектора до конца дорожки
; Окончание записи дорожки
17$:	TSTB	(R4)				; Готовность есть?
		BPL		17$					; Нет - ждём
		MOV		#47116, (R5)		; Запишем 4E4E
		TST		(R4)				; Индекс есть?
		BPL		17$					; Нет - продолжим запись до появления
18$:	TSTB	(R4)				; Готовность есть?
		BPL		18$					; Нет - дождёмся
		MOV		#47116, (R5)		; Запишем 4E4E
		TST		(R5)				; Прекратим запись
		MTPS	BUFPSW(R3)			; Восстановим PSW
		SWAB	SIDE(R3)			; Вернём все на место
		JMP		EXIT				; EXIT: Выходим
; ───────────────────────────────────────────────────────────────────────────
; Далее	следует	драйвер расширенной арифметики
EXT$V4:	MOV		@#6, -(SP)			; эмуляция прерывания по вектору 4
		BIS		#1, (SP)
		MOV		@#4, -(SP)
		RTI
; ───────────────────────────────────────────────────────────────────────────
;точка входа в драйвер расширенной арифметики
EXT:	MOV		#6, -(SP)
		ADD		SP, (SP)
		MOV		R5, -(SP)
		MOV		R4, -(SP)
		MOV		6(SP), R5
		MOV		-(R5), R4
		MOV		R3, -(SP)
		MOV		R2, -(SP)
		MOV		R1, -(SP)
		MOV		R0, -(SP)
		MOV		R4, R0
		MOV		R0, R1
		CMP		R0, #75000
		BHIS	FLOAT$
		JMP		EXTAR$
; ───────────────────────────────────────────────────────────────────────────
		ADD		#6, SP
ERRCM$:	CALL	RESTR$
		JMP		EXT$V4


;п/п установки признаков и восстановления регистров
RSTRS$:	BIC		#17, 22(SP)
		BIS		R5, 22(SP)


;п/п восстановления регистров
RESTR$:	MOV		(SP)+, 14(SP)
		MOV		(SP)+, R0
		MOV		(SP)+, R1
		MOV		(SP)+, R2
		MOV		(SP)+, R3
		MOV		(SP)+, R4
		MOV		(SP)+, R5
		RETURN
; End of function RESTR$
; End of function RSTRS$



Z64156:	CLR		R1
		CLR		R0
		ROR		R5
		BR		1$
; ───────────────────────────────────────────────────────────────────────────
2$:		ASR		R5
1$:		BCS		3$
		BNE		4$
		BR		5$
; ───────────────────────────────────────────────────────────────────────────
3$:		ADD		R4, R1
		ADC		R0
		ADD		R3, R0
4$:		ASL		R4
		ROL		R3
		BR		2$
; ───────────────────────────────────────────────────────────────────────────
5$:		RETURN
; End of function Z64156

; ───────────────────────────────────────────────────────────────────────────
FLOAT$:	CMP		R0, #75040		;точно float
		BLO		1$				;да
		JMP		ERRCM$			;нет - другие не эмулируемые опкоды
; ───────────────────────────────────────────────────────────────────────────
1$:		BIC		#177747, R0 ;определим тип опкода
		ASR		R0
		ASR		R0
		BIC		#177770, R1 ;определим номер регистра
		ASL		R1
		ADD		SP, R1
		MOV		R1, -(SP)
		MOV		(R1), R1
		MOV		(R1)+, R2
		MOV		(R1)+, R3
		MOV		(R1)+, R4
		MOV		(R1)+, R5
		MOV		R1, -(SP)
		ADD		PC, R0
		ADD		#OFSTBL-., R0
		ADD		(R0), PC
OFSTBL:	.WORD	FADD$-OFSTBL	;75000
		.WORD	FSUB$-OFSTBL	;75010
		.WORD	FMUL$-OFSTBL	;75020
		.WORD	FDIV$-OFSTBL	;75030
; ───────────────────────────────────────────────────────────────────────────

FDIV$:	CLR		-(SP)
		MOV		R2, R0
		BGT		1$
		BLT		2$
		JMP		FERR$
; ───────────────────────────────────────────────────────────────────────────
2$:		INC		(SP)
1$:		MOV		R4, R1
		BEQ		F3$
		BPL		4$
		INC		(SP)
4$:		CALL	Z64644
		SUB		R0, R1
		ADD		#37600, R1
		MOV		R1, -(SP)
		MOV		#100, R1
		CLR		R0
		BR		5$
; ───────────────────────────────────────────────────────────────────────────
6$:		ASL		R5
		ROL		R4
5$:		SUB		R3, R5
		SBC		R4
		SUB		R2, R4
		BMI		7$
8$:		SEC
		ROL		R1
		ROL		R0
		BCC		6$
		BR		9$
; ───────────────────────────────────────────────────────────────────────────
10$:	ASL		R5
		ROL		R4
		ADD		R3, R5
		ADC		R4
		ADD		R2, R4
		BPL		8$
7$:		CLC
		ROL		R1
		ROL		R0
		BCC		10$
9$:		MOV		R0, R2
		MOV		R1, R3
		JMP		F2$
; ───────────────────────────────────────────────────────────────────────────
F3$:	TST		(SP)+
		CLR		R2
		CLR		R3
		JMP		F1$
; ───────────────────────────────────────────────────────────────────────────

FMUL$:	CLR		-(SP)
		MOV		R2, R0
		BEQ		F3$
		BPL		1$
		INC		(SP)
1$:		MOV		R4, R1
		BEQ		F3$
		BPL		2$
		INC		(SP)
2$:		CALL	Z64644
		ADD		R0, R1
		SUB		#40000, R1
		MOV		R1, -(SP)
		MOV		R5, -(SP)
		MOV		R4, -(SP)
		MOV		R3, -(SP)
		MOV		R4, R3
		MOV		R5, R4
		MOV		R2, R5
		CALL	Z64156
		MOV		R1, -(SP)
		MOV		R0, -(SP)
		MOV		4(SP), R5
		BEQ		3$
		MOV		6(SP), R4
		CLR		R3
		CALL	Z64156
		ADD		R1, 2(SP)
		ADC		(SP)
		ADD		R0, (SP)
		MOV		10(SP), R4
		BEQ		3$
		MOV		4(SP), R5
		CLR		R3
		CALL	Z64156
		ADD		R0, 2(SP)
		ADC		(SP)
3$:		CLR		R2
		BISB	1(SP), R2
		MOV		2(SP), R1
		SWAB	R1
		MOVB	(SP)+, (SP)
		MOV		(SP)+, R3
		SWAB	R3
		ADD		#6, SP
		JMP		F4$



Z64644:	BIC		#100177, R0
		BIC		#100177, R1
		BIC		#177600, R2
		BIC		#177600, R4
		BIS		#200, R2
		BIS		#200, R4
		RETURN
; End of function Z64644

; ───────────────────────────────────────────────────────────────────────────

FSUB$:	TST		R2
		BEQ		FADD$
		ADD		#100000, R2

FADD$:	MOV		R2, R0
		BNE		1$
		MOV		R4, R2
		MOV		R5, R3
		BR		F1$
; ───────────────────────────────────────────────────────────────────────────
1$:		MOV		R4, R1
		BEQ		F1$
		BIC		#177600, R2
		BIS		#200, R2
		TST		R0
		BPL		2$
		NEG		R3
		ADC		R2
		NEG		R2
2$:		BIC		#177600, R4
		BIS		#200, R4
		TST		R1
		BPL		3$
		NEG		R5
		ADC		R4
		NEG		R4
3$:		BIC		#100177, R0
		BIC		#100177, R1
		CLR		-(SP)
		MOV		R0, -(SP)
		SUB		R1, R0
		BHI		4$
		BLO		5$
		CLR		R1
		BR		6$
; ───────────────────────────────────────────────────────────────────────────
5$:		MOV		R1, (SP)
		NEG		R0
		MOV		R2, R1
		MOV		R4, R2
		MOV		R1, R4
		MOV		R3, R1
		MOV		R5, R3
		MOV		R1, R5
4$:		CLR		R1
		CMP		R0, #6000
		BLE		7$
		CLR		R4
		CLR		R5
		BR		6$
; ───────────────────────────────────────────────────────────────────────────
7$:		ASL		R0
		SWAB	R0
8$:		ASR		R4
		ROR		R5
		ROR		R1
		SOB		R0, 8$

6$:		ADD		R5, R3
		ADC		R2
		ADD		R4, R2
		BPL		9$
		NEG		R1
		ADC		R3
		ADC		R2
		NEG		R3
		ADC		R2
		NEG		R2
		INC		2(SP)

9$:		MOV		R3, R4
		BIS		R1, R4
		BIS		R2, R4
		BNE		F2$
		CMP		(SP)+, (SP)+
		BR		F1$
; ───────────────────────────────────────────────────────────────────────────
F2$:	CMP		R2, #400
		BLO		F4$
		ASR		R2
		ROR		R3
		ROR		R1
		ADD		#200, (SP)
		BR		F2$
; ───────────────────────────────────────────────────────────────────────────
F4$:	TSTB	R2
		BMI		1$
2$:		SUB		#200, (SP)
		ASL		R1
		ROL		R3
		ROLB	R2
		BPL		2$
1$:		ASL		R1
		ADC		R3
		ADCB	R2
		BCC		3$
		ADD		#200, (SP)
3$:		MOV		(SP)+, R4
		BPL		4$
		CLR		R5
		ROL		R4
		BPL		F6$
		BR		F5$
; ───────────────────────────────────────────────────────────────────────────
4$:		ROR		(SP)+
		BCC		6$
		BIS		#100000, R2
6$:		BIC		#200, R2
		BIS		R4, R2

F1$:	CLR		R5
		TST		R2
		BNE		1$
		BIS		#4, R5
1$:		BPL		2$
		BIS		#10, R5
2$:		MOV		(SP)+, R1
		MOV		(SP)+, R0
		MOV		R3, -(R1)
		MOV		R2, -(R1)
		MOV		R1, (R0)
		SUB		SP, R0
		CMP		R0, #14
		BCS		3$
		BEQ		4$
		ADD		#4, 16(SP)
3$:		CALL	RSTRS$
		RTI
; ───────────────────────────────────────────────────────────────────────────
4$:		CALL	RSTRS$
		MOV		(SP)+, 2(SP)
		MOV		(SP)+, 2(SP)
		RTI
; ───────────────────────────────────────────────────────────────────────────
FERR$:	BIS		#1, R5
F5$:	BIS		#10, R5
F6$:	BIS		#2, R5
		CMP		(SP)+, (SP)+
		MOV		(SP)+, R0
		SUB		SP, R0
		CMP		R0, #16
		BNE		1$
		ADD		#10, 16(SP)
1$:		CALL	RSTRS$
		MOV		@#246, -(SP)
		MOV		@#244, -(SP)
		RTI
; ───────────────────────────────────────────────────────────────────────────

EXTAR$:	CMP		R0, #70000	;точно расширенная арифметика?
		BHIS	1$			;да
		JMP		ERRCM$		;нет - другие неэмулируемые опкоды
; ───────────────────────────────────────────────────────────────────────────
1$:		BIC		#170777, R0	;выделим код опкода
		SWAB	R0			;*2
		MOV		R1, R2
		BIC		#177770, R1	;выделим регистр источника
		ROL		R1			;*2
		ASR		R2
		ASR		R2
		MOV		R2, R3
		BIC		#177761, R2	;выделим код операции источника *2
		ASR		R3
		ASR		R3
		ASR		R3
		BIC		#177761, R3	;выделим регистр приемника  *2
		MOV		#2, R4
		BIS		R3, R4
		ADD		SP, R3
		ADD		SP, R4
		MOV		R1, -(SP)
		ADD		SP, R1
		ADD		#2, R1
		MOV		R2, -(SP)
		ADD		PC, (SP)
		ADD		#EPCBS2-., (SP)
		ADD		@(SP)+, PC
; ───────────────────────────────────────────────────────────────────────────
EPCBS2:	.WORD	OFFS04-EPCBS2	;0 Rx
		.WORD	OFFS04-EPCBS2	;1 (Rx)
		.WORD	OFFS05-EPCBS2	;2 (Rx)+
		.WORD	OFFS05-EPCBS2	;3 @(Rx)+
		.WORD	OFFS06-EPCBS2	;4 -(Rx)
		.WORD	OFFS06-EPCBS2	;5 @-(Rx)
		.WORD	OFFS07-EPCBS2	;6 n(Rx)
		.WORD	OFFS07-EPCBS2	;7 @n(Rx)
; ───────────────────────────────────────────────────────────────────────────
OFFS05:	INC		(SP)
		MOV		(R1), R5
		ADD		#2, (R1)
		BR		ARROP$
; ───────────────────────────────────────────────────────────────────────────
OFFS06:	SUB		#2, (R1)
		MOV		(R1), R5
		BR		ARROP$
; ───────────────────────────────────────────────────────────────────────────
OFFS07:	MOV		@20(SP), R5
		ADD		#2, 20(SP)
		ADD		(R1), R5
		BR		ARROP$
; ───────────────────────────────────────────────────────────────────────────
OFFS04:	MOV		R1, R5
ARROP$:	BIT		#2, R2		;адресация относительная?
		BEQ		1$			;нет
		MOV		(R5), R5	;да - адрес адреса
1$:		MOV		R4, -(SP)
		MOV		R3, -(SP)
		ADD		PC, R0
		ADD		#OFSTB2-., R0
		ADD		(R0), PC
; ───────────────────────────────────────────────────────────────────────────
OFSTB2:	.WORD	MUL$-OFSTB2		;70000
		.WORD	DIV$-OFSTB2		;71000
		.WORD	ASH$-OFSTB2		;72000
		.WORD	ASHC$-OFSTB2	;73000
		.WORD	XOR$-OFSTB2		;74000
; ───────────────────────────────────────────────────────────────────────────
MUL$:	MOV		(R3), R4
		BEQ		2$
		MOV		(R5), R5
		BEQ		2$
		BPL		1$
		NEG		R4
		NEG		R5
		BPL		1$
		MOV		R4, R3
		MOV		R5, R4
		MOV		R3, R5
		BPL		1$
		NEG		R5
		BMI		4$
1$:		TST		R4
		SXT		R3
		CALL	Z64156
		TST		R1
		SXT		R2
		CMP		R0, R2
		BEQ		3$
		BIS		#1, R5
3$:		JMP		EARX1$
; ───────────────────────────────────────────────────────────────────────────
2$:		CLR		R0
		CLR		R1
		CLR		R5
		JMP		EARX1$
; ───────────────────────────────────────────────────────────────────────────
4$:		MOV		#40000, R0
		CLR		R1
		CLR		R5
		BR		3$
; ───────────────────────────────────────────────────────────────────────────
DIV$:	CLR		-(SP)
		MOV		(R3), R0
		MOV		(R4), R1
		MOV		R0, -(SP)
		BPL		1$
		INC		2(SP)
		NEG		R1
		ADC		R0
		NEG		R0
		BMI		2$
1$:		MOV		(R5), R4
		BEQ		3$
		BPL		4$
		INC		2(SP)
		NEG		R4
		BMI		2$
4$:		CLR		R5
		CMP		R0, R4
		BGT		2$
		BLT		5$
		CMP		R1, R4
		BHIS	2$
5$:		CLR		R2
		MOV		#20, R3
6$:		ASR		R4
		ROR		R5
		SUB		R5, R1
		SBC		R0
		SUB		R4, R0
		BMI		7$
8$:		SEC
		ROL		R2
		SOB		R3, 6$
		BR		9$
; ───────────────────────────────────────────────────────────────────────────
10$:	ASR		R4
		ROR		R5
		ADD		R5, R1
		ADC		R0
		ADD		R4, R0
		BPL		8$
7$:		CLC
		ROL		R2
		SOB		R3, 10$
		ADD		R5, R1
9$:		TST		(SP)+
		BPL		11$
		NEG		R1
11$:	ASR		(SP)+
		BCC		12$
		NEG		R2
12$:	CLR		R5
		MOV		R2, R0
		BPL		13$
		BIS		#10, R5
13$:	BNE		14$
		BIS		#4, R5
14$:	JMP		EARX2$
; ───────────────────────────────────────────────────────────────────────────
3$:		MOV		#3, R5
		BR		15$
; ───────────────────────────────────────────────────────────────────────────
2$:		MOV		#2, R5
15$:	ADD		#10, SP
		JMP		EARX3$



Z66176:	CLR		R2
		MOV		(R3), R0
		MOV		(R5), R5
		BIT		#40, R5
		BEQ		1$
		BIS		#177700, R5
		NEG		R5
		RETURN
; ───────────────────────────────────────────────────────────────────────────
1$:		BIC		#177700, R5
		RETURN
; End of function Z66176

; ───────────────────────────────────────────────────────────────────────────
ASH$:	MOV		R3, 2(SP)
		CALL	Z66176
		BEQ		1$
		BCS		2$
3$:		ASL		R0
		BVC		4$
		INC		R2
4$:		SOB		R5, 3$
		BR		1$
; ───────────────────────────────────────────────────────────────────────────
2$:		ASR		R0
		SOB		R5, 2$
1$:		MOV		R0, R1
		BR		EARX4$
; ───────────────────────────────────────────────────────────────────────────
ASHC$:	MOV		(R4), R1
		CALL	Z66176
		BEQ		EARX4$
		BCS		1$
2$:		ASL		R1
		ROL		R0
		BVC		3$
		INC		R2
3$:		SOB		R5, 2$
		BR		EARX4$
; ───────────────────────────────────────────────────────────────────────────
1$:		ASR		R0
		ROR		R1
		SOB		R5, 1$
		BR		EARX4$
; ───────────────────────────────────────────────────────────────────────────
XOR$:	CMP		(SP)+, (SP)+	;типа игнорируется? могли бы и заэмулировать. это не так и трудно
		BR		EARX3$
; ───────────────────────────────────────────────────────────────────────────
EARX4$:	ADC		R5
		TST		R2
		BEQ		EARX1$
		BIS		#2, R5
EARX1$:	TST		R0
		BPL		1$
		BIS		#10, R5
1$:		BNE		EARX2$
		TST		R1
		BNE		EARX2$
		BIS		#4, R5
EARX2$:	MOV		R0, @(SP)+
		MOV		R1, @(SP)+
EARX3$:	CMP		(SP)+, #15
		BEQ		2$
		CALL	RSTRS$
		RTI
; ───────────────────────────────────────────────────────────────────────────
2$:		CALL	RSTRS$
		MOV		2(SP), 4(SP)
		MOV		(SP)+, (SP)
		RTI

; подготовка перед загр
PGRUZ:	MOV		#2000,R3
;прогр запоминания SP,PSW,@#4
PREDS:	MOV		#IF7,R4
STORSP:	MFPS	BUFPSW(R3)				; Сохраним PSW,
		MOV		SP, BUFSP(R3)			;   SP,
		ADD		#2, BUFSP(R3)			; скорректируем значение сохранённого SP
		MOV		#4, R0
		MOV		(R0), BUF4(R3)			;  @#4 в соответствующих буферах
		MOV		PC, (R0)				; Переназначаем вектор @#4 на себя,
		ADD		#VECT4-., (R0)			;    теперь он равен 161512
		RETURN


; ───────────────────────────────────────────────────────────────────────────


; FIZIKH: П/п чтения-записи по номеру сектора для HDD
FIZIKH:	CLR		R0						; пересчет дор/стор/сект в блоки...
		MOV		MAXSEC(R3),R2			; кол-во секторов на дорожке
		CLR		R1
		BISB	TRK(R3),R1				; номер дорожки
		BEQ		1$						; если 0 - не надо умножать
2$:		ADD		R1,R0					; дорожка * секторов_на_дорожке(максимум 10) * кол-во_сторон (максимум 2)
		SOB		R2,2$
		ASL		R0						; умножаем на кол-во сторон
1$:		TSTB	SIDE(R3)				; сторона 0?
		BEQ		3$						; да
		ADD		MAXSEC(R3),R0			; сторона 1 - ещё прибавим кол-во секторов на дорожке
3$:		MOVB	SECTOR(R3),R1			; номер сектора, они начинаются с 1
		DEC		R1						; в номер блока
		ADD		R1,R0					; добавляем
		MOV		R0,HD.BLK(R3)			; и вот получился номер блока логического диска.

;П/п чтения-записи по номеру блока для HDD
;вход -	номер блока в HD.BLK(R3)
;		длина в	WCNT(R3)
;		адрес в	ADDR(R3)
OBMEN:	CALL	PREDS					; сохраняем SP, PSW, @#4 
		CLRB	@#ERRFDD
		MOV		#HLT,@#4				; и перенаправляем вектор 4 на себя.
		CALL	ZAG						; грузимся
		TSTB	@#ERRFDD				; ошибки есть?
		BEQ		1$						; нету - нормальный выход
		JMP		VECT4					; выход с ошибкой

1$:		JMP		ENDS					; выход без ошибок

ZAG:	CALL	INDR.N					; переместимся к заданному разделу и прочтём его параметры
		MOV		WCNT(R3),R2				; количество слов 
		BPL		100$
		NEG		R2						; и конца лог диска
100$:	MOV		R2,R5
		ADD		#377,R5					; выравниваем
		CLRB	R5						; по границе блока
		SWAB	R5						; и получаем размер в блоках
		MOV		R5,R1
		ADD		HD.BLK(R3),R1			;вычислим конечный блок 
		CMP		R1,LD.VOL(R3)			;он в пределах раздела? (LD.VOL - ёмкость раздел    а в блоках)
		BLOS	200$
		CALL	ENO
		.WORD	4

200$:	;BIT	#1,LD.FLG(R3)
		;BEQ	300$
		;дописать обход битых секторов
		;данные о них хранятся в блоке - 3
300$:	MOV		R5,R1
		COM		R1
		MOV		R1,@#IF2				;количество блоков -> счетчик
		SWAB	R5
		SUB		R2,R5
		MOV		R5,BLKCNT(R3)			;остаток слов в последнем блоке, которые надо пропустить
		MOV		HD.BLK(R3),R0
		CALL	REGI4
		MOV		ADDR(R3),R1				;-Adres
		MOV		WCNT(R3),R2				;-длина
		BMI		3$						;<0 - запись
		BIT		#20,LD.FLG(R3)			;читать можно?
		BNE		5$						;нет
		MOV		#337,(R4)				;команда 0x20 - чтение
		CALL	READ1					;читаем массив
		MOV		BLKCNT(R3),R2			;остаток есть?
		BEQ		11$						;нету
		CALL	READF					;фиктивно прочитаем остаток буфера
11$:	RETURN

5$:		CALL	ENO
		.WORD	1						;защита OT ЧТ/ЗАП

3$:		NEG		R2						;запись
		BIT		#10,LD.FLG(R3)			;писать можно?
		BNE		5$						;нет
		MOV		#317,(R4)				;команда 0x30 - запись
		CALL	WRITE1					;пишем массив
		MOV		BLKCNT(R3),R2			;остаток есть?
		BEQ		12$						;нету
		CALL	WRITEF					;добиваем нулями
12$:	RETURN

;подсчёт контрольной суммы бл. пар.
CONTR:	CLR		R5
		BISB	UNIT(R3),R5				;ном винта
		ADD		CYLVOL(R3),R5			;емк ц
		ADC		R5
		ADD		HD.SEC(R3),R5			;емк д
		ADC		R5
		ADD		LDBLLO(R3),R5			;ном бл
		ADC		R5
		ADD		LDBLHI(R3),R5			;ном бл
		ADC		R5
		RETURN

;внесение параметров в регистры винта по номеру блока  R0
;ВНИМАНИЕ ! ! ! перед этой программой сделай CONTR
REGI4:	INC		R0
REGI:	CALL	T120				;проверим готовность принять команду
		MOV		LDBLHI(R3),R1		;номер блока ST
		ADD		LDBLLO(R3),R0		;номер блока ML
		ADC		R1
		;делим	номер блока на объём цилиндра = число головок * число секторов на дорожке
		CALL	DIV2				;R1:R0 / CYLVOL(R3), Выход: R0 - результат, R5 - остаток
		;в результате получаем номер дорожки в R0 и остаток.
		COM		R0					;номер цилиндра выбранного винта
		MOV		R0,@#IF4
		SWAB	R0
		MOV		R0,@#IF5
;R5 - остаток
		MOV		R5,R0
		CLR		R2
		BISB	HD.SEC(R3),R2
		;делим	остаток на количество дорожек
		CALL	DIV1				;R0 / R2, Выход: R0 - результат, R5 - остаток
		;в результате получаем номер головки в R0 и номер сектора на дорожке в R5
		COM	 R0
		;Для режима MASTER-SLAVE.
		;PUSH	R1
		;MOV	@#IF6,R1
		;BIC	#177757,R1
		;BIS	R1,R0
		;POP	R1
		MOVB	R0,@#IF6			;головка
		INC		R5					;корректируем номер сектора, они начинаются с 1
		COM		R5
		MOVB	R5,@#IF3			;сектор
		RETURN

;перехват функции загрузки с винта
BOOTF:	TST		R0					;если R0<0
		BMI		GRUZ0D				;то это загрузка с винта, автоматическая.
		MOV		#2000, R3			; Установим адрес рабочей области           
		CALL	INIT				; INIT:  и инициализируем ее
		MOVB	R0, UNIT(R3)		; Занесём номер привода
		RETURN

GRUZ0D:	CALL	(PC)
		CALL	(PC)
		CALL	PGRUZ				;инициализация и сохраняем SP, PSW и т.п.
		MOV		#20,R1
10$:	CLR		R2
9$:		TSTB	@#IF7				; смотрим бит 7(BSY) регистра состояния
		BMI		8$					; если сброшен, то всё нормально
		SOB		R2,9$				; иначе ждём.
		SOB		R1,10$
		RETURN						; так и не дождались - выходим.

8$:		CALL	IND00
		BR		71L$

;загрузка с выбранного раздела HDD, R0 - номер раздела
GRUZND:	CALL	PGRUZ				; инициализация и сохраняем SP, PSW и т.п.
		MOVB	R0,UNIT(R3)			;
		CALL	INDRV
71L$:	CALL	CMPDR				;+1
		CALL	READFP
		.WORD	377					;+400
		MOV		#1000,ADDR(R3)		;адрес загрузки
		MOV		#400,WCNT(R3)		;число слов
		CLR		HD.BLK(R3)			;блок 0
		CALL	ZAG					; Прочитаем...
		MOV		#1000,R2
		CMP		#240,(R2)+			; Загрузчик начинается с NOP?
		BNE		1EZ$				; Нет - выход
		CMP		#5,(R2)				; Вторая команда - RESET?
		BEQ		1EZ$				; Да - диск не системный, выход
		MOVB	UNIT(R3),R0			; Вспомним, откуда это мы загрузились
		JMP		-(R2)				; а то RT-11 не грузится... Запускаем загрузчик

1EZ$:	CALL	ENO					;выходим с ошибкой 10
		.WORD	10

CMPDR:	CLR		R0
		CALL	REGI				;заполняем регистры
		MOV		#376,@#IF2			;1->1f2 (счетчик = 1)
		MOV		#337,(R4)			;команда 0x20 - чтение
		CALL	READP
		.BYTE	LD.NUM, 1
;   LD.NUM(R3) должен быть=номеру лог диска - признак -4го блока
		CMPB	LD.NUM(R3),UNIT(R3)	;номера совпадают?
		BNE		1$					;нет - ошибка
		RETURN						;да - порядок

1$:		CALL	READFP				;прочитаем остальные слова из буфера
		.WORD	377
		CALL	ENO					;выход с ошибкой - не совпал признак начала диска
		.WORD	3

;чтение	 параметров выбранного дисковода
INDR.N:	CALL	CONTR				;подсчитаем контрольную сумму геометрии и параметров раздела
		CMP		R5,MBRCRC(R3)		;сравним её с текущей
		BEQ		1$					;если сумма та же, то всё в норме
		CALL	INDRV				;снова перечитаем конфиг винта
1$:		CALL	CMPDR				;пойдём читать первый блок раздела
;    LD.VOL(R3)	емкость винта
;    LD.FLG(R3)	признаки
; ФОРМАТ БАЙТА ПРИЗНАКОВ ДИСКА
;10-полн.защ от	записи
;20-полн.защ от	чтения
;40
;100
;200
		CALL	READP				;читаем ещё два слова
		.BYTE	LD.VOL, 2
		CALL	READFP				;и пропустим остаток буфера
		.WORD	375
		RETURN

IND36:	CALL	T120				;проверим готовность принять команду
		MOV		#377,R0
		MOV		R0,@#IF6			;0->1f6 (НЖМД 0, головка 0)
		MOV		R0,@#IF5			;0->1f5 (дорожка 0 ст.)
		MOV		R0,@#IF4			;0->1f4 (дорожка 0 мл.)
		DEC		R0
		MOV		R0,@#IF2			;1->1f2 (счётчик секторов)
		DEC		R0
		MOV		R0,@#IF3			;2->1f3 (сектор 2 - блок 1)
		MOV		#337,(R4)			;команда 0x20 - чтение
		CALL	READP				;читаем данные в блок параметров
		.BYTE	LD.VOL, 1
		CALL	READP				;читаем данные в блок параметров
		.BYTE	CYLVOL, 2
;   в LD.VOL(R3)- номер привода нач заг
;   в CYLVOL(R3)- объем цилиндра
;   в HD.SEC(R3)- объем дорожки
;   в HD.SEC+1(R3)- кол-во головок
		RETURN

IND00:	CALL	IND36
		MOVB	LD.VOL(R3),UNIT(R3) ;вот с этого привода надо загружаться
		BR		390L$

;чтение параметров винта, No его блока
;в R3 адрес блока параметров
INDRV:	CALL	IND36
390L$:	MOVB	UNIT(R3),R2			;номер привода для загрузки
		SUB		#2,R2				;делаем, чтобы начиналось с 0 
		BEQ		1$					;если 0 - ничего делать не надо
		ASL		R2					;умножаем на 2
		CALL	READF				;смещаемся в таблице к нужному разделу
1$:		CALL	READP				;LDBLLO(R3)мл\ нач. номер блока привода
		.BYTE	60, 2				;LDBLHI(R3)ст/
		MOVB	UNIT(R3),R1			;номер привода для загрузки
		ASL		R1
		INC		R1
		MOV		#400,R2				;вычислим остаток слов 
		SUB		R1,R2				;которые надо прочитать из буфера
		CALL	READF				;читаем.
		CALL	CONTR				;посчитаем контрольную сумму
		MOV		R5,MBRCRC(R3)		;и сохраним её
		RETURN

;программа проверки готовности
BSYH:	TSTB	(R4)				;смотрим бит 7(BSY) регистра состояния
		BPL		1$					;если установлен
		RETURN						;если сброшен, то нормально

1$:		CLR		R5					;если установлен - подождём
2$:		TSTB	(R4)				;смотрим бит 7(BSY) регистра состояния
		BMI		BSYH				;если сброшен, пойдём ещё раз перепроверим
		SOB		R5,2$				;если установлен - ждём
		CALL	ENO					;не дождались - выходим с ошибкой
		.WORD	3

;проверка готовности принять команду
T120:	CALL	BSYH				;проверим готовность
		BIT		#120,(R4)			;смотрим биты 6(DRDY) и 4(DSC) регистра состояния
		BNE		1$					;если хоть один не установлен - пойдём подождём
		BIT		#10,(R4)			;бит 3(DRQ) регистра состояния - запрос на обмен данными
		BEQ		3$					;если установлен - переход
		RETURN						;6(DRDY) и 4(DSC) установлены - порядок

1$:		CLR		R5					;подождём установки
10$:	BIT		#120,(R4)			;смотрим биты 6(DRDY) и 4(DSC) регистра состояния
		BEQ		T120				;оба установлены - пойдём ещё раз всё перепроверим
		SOB		R5,10$				;если хоть один не установлен - ждём
		CALL	ENO					;не дождались - выходим с ошибкой
		.WORD	6

3$:		MOV		#0,@#ZF6			;выполним soft reset (бит 2)
		MOV		#2000,R5
33$:	SOB		R5,33$				;задержка
		MOV		#377,@#ZF6			;сбросим бит soft reset 
		CALL	ENO					;не закончена предыдущая команда
		.WORD	5

;проверка готовности обмена
T130:	CALL	BSYH				;проверим готовность
		BIT		#130,(R4)			;смотрим биты 6(DRDY), 4(DSC) и 3(DRQ) регистра состояния
		BNE		1$					;если хоть один не установлен - пойдём подождём
		RETURN						;если все установлены - порядок

1$:		CLR		R5					;подождём установки
10$:	BIT		#130,(R4)			;смотрим биты 6(DRDY), 4(DSC) и 3(DRQ) регистра состояния
		BEQ		T130				;все три установлены - пойдём ещё раз всё перепроверим
		SOB		R5,10$				;если хоть один не установлен - ждём
		CALL	ENO					;не дождались - выходим с ошибкой
		.WORD	10

;чтение из буфера в заданные ячейки блока параметров
READP:	MOV		(SP),R2				;адрес возврата
		MOVB	(R2)+,R1			;смещение в блоке параметров
		MOVB	(R2)+,R2			;количество слов
		ADD		R3,R1				;адрес в блоке параметров
		ADD		#2,(SP)				;корректируем адрес возврата
;чтение BLOKа  в  R1+
READ1:
1$:		CALL	T130				;подождём готовности обмена
0$:		TSTB	(R4)				;смотрим бит 7(BSY) регистра состояния
		BPL		1$					;если винт занят - идём снова ждать
		MOV		@#IF0,(R1)+			;чтение из регистра данных 
		SOB		R2,0$				;сколько нужно слов
		RETURN

;запись BLOKа из  R1+
WRITE1:
1$:		CALL	T130				;подождём готовности обмена
0$:		TSTB	(R4)				;смотрим бит 7(BSY) регистра состояния
		BPL		1$					;если винт занят - идём снова ждать
		MOV		(R1)+,@#IF0			;запись в регистр данных 
		SOB		R2,0$				;сколько нужно слов
		RETURN

READFP:	MOV		(SP),R2				;адрес возврата
		ADD		#2,(SP)				;корректируем адрес возврата
		MOV		(R2),R2				;количество слов для чтения
;фиктивное чтение
READF:
1$:		CALL	T130				;подождём готовности обмена
0$:		TSTB	(R4)				;смотрим бит 7(BSY) регистра состояния
		BPL		1$					;если винт занят - идём снова ждать
		MOV		@#IF0,R5			;чтение из регистра данных 
		SOB		R2,0$				;сколько нужно слов
		RETURN
;фиктивная запись
WRITEF:
1$:		CALL	T130				;подождём готовности обмена
0$:		TSTB	(R4)				;смотрим бит 7(BSY) регистра состояния
		BPL		1$					;если винт занят - идём снова ждать
		MOV		#0,@#IF0			;запись в регистр данных 
		SOB		R2,0$				;сколько нужно слов
		RETURN

;деление R1 - старш. R0 - младш.
;     на R2 - CYLVOL(R3)
DIV2:	MOV		CYLVOL(R3),R2		;объем цилиндра
DV2:	MOV		R4,-(SP)
		MOV		#40,R4
		CLR		R5
1$:		ASL		R0
		ROL		R1
		ROL		R5
		CMP		R2,R5
		BHI		2$
		SUB		R2,R5
		ADD		#1,R0
		ADC		R1
2$:		SOB		R4,1$
		BR		88L$

;деление R0 на R2
DIV1:	MOV		R4,-(SP)
		MOV		#20,R4
		CLR		R5
1$:		ASL		R0
		ROL		R5
		CMP		R2,R5
		BHI		2$
		SUB		R2,R5
		INC		R0
2$:		SOB		R4,1$
88L$:	MOV		(SP)+,R4
		RETURN	;R0-результат  R5-остаток

;хитрая обработка "СТОП"
HLT:	INCB	@#ERRFDD
		SUB		(PC),(SP)
		RTI



		.END



Блок 0 - ?
Блок 1:
    со смещения 0 - геометрия
    смещение    длина   значение
        0       2       номер привода нач заг
        2       2       объем цилиндра - это произведение числа головок на число секторов
        4       1       объем дорожки - это количество секторов
        5       1       номер последней головки - (кол-во головок - 1)
    со смещения 6 начинается таблица разделов. на один раздел - 4 байта
        двойное слово - номер блока начала раздела.

первый блок раздела:
    смещение    длина   значение
        0       1       номер привода
        1       1       ?
        2       2       ёмкость винта (может раздела?)
        4       2       флаги-признаки

Формула пересчёта chs в блок нестандартная.
blk = xc * H*S + xh * S + xs - 1;
где
xc - текущий номер дорожки
xh - текущий номер головки
xs - текущий номер сектора
C - количество дорожек
H - количество головок
S - количество секторов на дорожке
